'Sterownik owietlenia
'Kamil Kozowski
'kamilkozi@wp.pl

$regfile = "2313DEF.dat"
$crystal = 10000000

Dim Eaddress As Eram Byte At 2                              'adres pilota Rc5, zosata umieszczony pod adresem 2 gdy z doswiadczenia wiem, e komrki 0 i 1(szczeglnie 0) pamici EEPROM potrafi si skasowa przy nagych skokach napicia zasilania
Dim Epamiec(16) As Eram Byte At 3                           'tablica komend przyciskw pilota


Dim Lmram(4) As Byte                                        'cztery zmienne w ktrych jest przechowywana informacja o aktualnym stanie jasnosci lamp
Dim Address As Byte , Command As Byte                       'zmienne potrzebne do RC5
Dim Licznik As Byte                                         ' ta zmienna jest potrzebna przy odliczaniu czasu niewiecenie kadej lampy
Dim Ktora As Byte                                           'ta zmienna okrela ktra lampa jest sterowana
Dim Digit As Byte                                           'zmienna potrzebna przy zapisie odczycie pamici eeprom
Dim Nextlm As Byte                                          'zmienna pomocnicza
Dim Upbit As Byte                                           '}
Dim Downbit As Byte                                         ' }te zmienne przyjmuja tylko wartoci 0 lub 255 - czyli w programie s traktowane jako bity
                                                              ' (operacje na bajtach zajmuj mniej pamici FLASH, ale wicej RAMu) ustawiane s po nacisnieciu odp. przycisku na klawiaturze lub pilocie
Dim Onoffall As Byte                                        'bit mwicy o wczeniu/wyczeniu czterech lamp
Dim Kod As Byte                                             'bit(patrz wyzej Upbit, Downbit) pomocniczy przy ustalaniu czy przycisk na pilocie jest trzymany

Dim Pomocbit As Byte                                        '}
Dim Pomocbit2 As Byte                                       ' }bity pomocnicze do zapamitywania upbit i downbit

Dim X As Byte                                               'zmienna potrzebna do odliczania czasu trzymania przycisku na pilocie potrzebnego do zapisania profilu
Dim Pomocbit3 As Byte                                       'bit pomocniczy
Dim Adr As Byte                                             'w tej zmiennej przechowywany jest obliczony adres dostepu do potrzebnego obszaru pamieci eeprom

Dim Eonofflmgl As Eram Byte At 100                          'tu zapamietywana jest ostatnia warto zmiennej Onofflmgl
Dim Onofflmgl As Byte                                       'zmienna mwiaca o wczeniu/wyczeniu lampy gwnej

Dim K As Integer                                            'zmienna pomocna przy sprawdzaniu czy przycisk zosta puszczony
Dim Pomocbit4 As Byte


Config Portb = &B01111000
Config Portd = &B0111011                                    'wyjcia/wejscia Portu D zostan odpowiednio ustawione(podcignite) ju przy pierwszym skoku do podprogramu Inttim1
Gosub Incrktora                                             '}
Gosub Selectktora                                           ' }te dwa polecenia daj w sumie ustawienie (podcignicie) we./wy. portu B

Dim Timefader As Byte                                       ')
Dim Timefader2 As Byte                                      ' )zmienne do odliczania czasu automatycznego gaszenia lamp

Config Int0 = Falling
Config Rc5 = Pind.2

Config Timer1 = Timer , Prescale = 1

Enable Interrupts
Enable Timer1

On Timer1 Inttim1
On Int0 Int_0

Config Watchdog = 2048                                      'jeli program si zawiessi to watcghdog zresetuje go po ok 2s

Onofflmgl = Eonofflmgl                                      'wpisanie do onofflmgl takiej wartosci jaka bya przed wyaczeniem zasilania

$asm
      sbis pinb, 0                                          'jeli wcinity jest przycisk down to
$end Asm
  Gosub Pilot                                               'skocz do podprogramu zapisujacego komendy pilota


Do                                                          'tu zaczyna si program gwny
  Start Watchdog
  If Address = Eaddress Then                                'jeli adres pilota dobry
    For Nextlm = 1 To 16                                    'pitnastokrotnie
      If Command = Epamiec(nextlm) Then                     'sprawdzanie komend przyciskw pilota
       Select Case Nextlm
         Case 1 : Gosub Incrktora                           'Incr Ktra
         Case 2 : Gosub Setupbit                            'przycisk Up
         Case 3 : Gosub Setdownbit                          'przycisk Down
         Case 4 : If Kod = 0 Then                           'po to by jednokrotnie zmienic stan onoffall przy jednokrotnym nacisnieciu przycisku pilota
                    Onoffall = Not Onoffall
                    Gosub Setkod
                  End If
         Case 5 : If Kod = 0 Then                           'po to by jednokrotnie zmienic stan onofflmgl przy jednokrotnym nacisnieciu przycisku pilota
                    Onofflmgl = Not Onofflmgl
                    Eonofflmgl = Onofflmgl
                    Gosub Setkod
                  End If
         Case 6 : If Kod = 0 Then                           'po to by jednokrotnie zmienic stan DDRB.7 przy jednokrotnym nacisnieciu przycisku pilota
                    Ddrb.7 = Not Ddrb.7                     'przeczanie PORTD.7 jako we. lub wy. co daje wczanie i wyczanie Timer Fadera
                    Gosub Setkod
                  End If
         Case Is >= 7 :
                       Incr X                               'zwiekszanie zmiennej X
                       Adr = Nextlm                         '}obliczanie adresu dla pamieci eeprom]
                       Shift Adr , Left , 2
                       If X = 10 Then                       'po ok 1s przyciskania klawisza
                         For Digit = 1 To 4
                           Writeeeprom Lmram(digit) , Adr   'zapis do eeprom wartosci jasnosci lamp danego profilu
                           Gosub Waitms50                   'czas dla EEPROMa na zapis
                           Incr Adr
                         Next Digit
                         Gosub Mrugnij
                         Pomocbit3 = 0
                       Else
                         Pomocbit3 = 255                    'blokowanie odczytu z EEPROM jeli przycisk jest trzymany
                       End If
       End Select
      End If
    Next Nextlm
    Gosub Address_255
    K = 0
  Else
    Incr K
    If K >= 5000 Then
      Kod = 0
      X = 0
      If Pomocbit3 = 255 Then                               'Zezwolenie Na Odczytanie Z Eeprom
        Pomocbit3 = 0
        For Digit = 1 To 4
          Readeeprom Lmram(digit) , Adr                     'odczyt z eproma wartoci jasnosci lamp w danym profilu
          Incr Adr
        Next Digit
      End If
    End If
  End If
  Enable Int0

    $asm
      sbis pinb, 7
    $end Asm
      Gosub Timefadsub

    $asm
      sbis pinb, 1                                          'przycisk up
    $end Asm
       Gosub Wait_setupbit

    $asm
      sbis pinb, 0                                          'przycisk down
    $end Asm
        Gosub Wait_setdownbit

  $asm
    sbis pinb, 2                                            'przycisk next
  $end Asm
    Gosub Incrktora

  If Ktora >= 7 Then Ktora = 1                              'skracanie cyklu licznika ktra
  Gosub Selectktora
  Gosub Upbitsub
  Reset Watchdog
Loop
End



Inttim1:                                                    'co ok 97us
  Portd.0 = Onofflmgl.0                                     'zapalanie/gaszenie lampy gwnej
  Timer1 = 64566                                            'timer1 liczy 970 cylki zegara, czyli przerwanie co ok 97us
  If Licznik >= 50 Then
    $asm
      sbic pind, 6                                          'sprawdzaj stan kocwki PIND6, jeli jest rwna 1 to
    $end Asm
      Gosub Zero                                            'skocz do podprogramu Zero
  End If
  Incr Licznik
  If Onoffall = 255 Then                                    'jei zezwolenie globalne na wczanie lamp = 1 to
    If Licznik > Lmram(1) Then Reset Portd.5                '}
    If Licznik > Lmram(2) Then Reset Portd.4                ' } zapalaj odpowiednio lampy do wartoci tablicy Lmram
    If Licznik > Lmram(3) Then Reset Portd.3                '}
    If Licznik > Lmram(4) Then Reset Portd.1                '}
  End If
Return

Upbitsub:
  If Upbit = 255 Then
    Gosub Resetupbit
    Decr Lmram(ktora)
  End If
  If Lmram(ktora) = 101 Then Lmram(ktora) = 100             'po to by lmram(ktra) utrzymywana bya w granicach 0 - 161

  If Downbit = 255 Then
    Gosub Resetdownbit
    Incr Lmram(ktora)
  End If
  If Lmram(ktora) = 255 Then Lmram(ktora) = 0               'jeeli zmniejszymy lmram(ktra) ponizej 0 to przyjmie ona war. 255 i po tym poleceniu znowu 0
Return

Selectktora:
  Select Case Ktora
   Case 1 : Portb = &B00111000                              'wieci LED4
   Case 2 : Portb = &B01011000                              'wieci LED3
   Case 3 : Portb = &B01101000                              'wieci LED2
   Case 4 : Portb = &B01110000                              'wieci LED1
   Case 5 : Portb = &B00000000                              'wiec od LED1 do LED4   ,wszystkie lampy janiej/ciemniej

            For Ktora = 1 To 4
              Pomocbit = Upbit
              Pomocbit2 = Downbit
              Gosub Upbitsub
              Upbit = Pomocbit
              Downbit = Pomocbit2
            Next Ktora
            Gosub Resetupbit
            Gosub Resetdownbit
            Ktora = 5
   Case 6 : Portb = &B01111000                              'tryb wczania/wyczania lamp
            Stop Watchdog

            $asm
              sbis pinb, 1                                  'przycisk up
            $end Asm
              Gosub Tog_all
            Bitwait Pinb.1 , Set                            'po to by jednoktrotnie zmienic stan onoffall przy jednokrotnym nacisniciu przycisku up na klawiaturze

            $asm
              sbis pinb, 0                                  'przycisk down
            $end Asm
              Gosub Tog_lmgl
            Bitwait Pinb.0 , Set                            'po to by jednoktrotnie zmienic stan onofflmgl przy jednokrotnym nacisniciu przycisku down na klawiaturze

  End Select
  If Pomocbit4 = 255 Then                                   'opnienie dla zmieniania trybu (ktora)
    $asm
      sbis pinb, 2                                          'przycisk next
    $end Asm
      Gosub Waitms200
    $asm
      sbis pinb, 2                                          'przycisk next
    $end Asm
      Gosub Waitms200
    Gosub Address_255
  End If
  Pomocbit4 = 0

Return

Tog_all:
  Onoffall = Not Onoffall
Return

Tog_lmgl:
  Onofflmgl = Not Onofflmgl
  Eonofflmgl = Onofflmgl
Return

Pilot:                                                      'procedurka rejestracji pilota
Do
    If Address <> 255 Then
      If Downbit = 0 Then
        Gosub Setdownbit                                    'by wykona tylko raz przy jednym nacisniciu przycisku
        If Upbit = 0 Then
          Eaddress = Address
          Gosub Setupbit                                    'adres jest zapisywany tylko raz(od jednego(pierwszego) przycisku))
        End If
        Epamiec(ktora) = Command
        Gosub Incrktora                                     'Incr Ktra
        Gosub Mrugnij
      End If
      K = 0
    Else
      Incr K
      If K >= 19000 Then Gosub Resetdownbit
    End If
    Gosub Address_255
    Enable Int0
Loop
Return

Address_255:
  Address = 255
Return

Setkod:
  Kod = 255
Return

Setupbit:
  Upbit = 255
Return

Setdownbit:
  Downbit = 255
Return

Resetupbit:
  Upbit = 0
Return

Resetdownbit:
  Downbit = 0
Return

Waitms50:
  Waitms 60
Return

Zero:
  Licznik = 1                                               'przy kazdym przechodzeniu napiecia sieci przez zero zeuj licznik i
  Portd = Portd Or &B1111110                                'wygas wszystkie 4 lampy
  Incr Timefader
Return

Timefadsub:                                                 '
  If Timefader = 100 Then                                   'co 1s
    Timefader = 0
    Incr Timefader2
    If Timefader2 = 12 Then                                 'co 12s ta linijka decyduje co ile czasu ma nastpi ciemnienie wiata o jeden kroczek
      Timefader2 = 0
      Gosub Setdownbit
    End If
  End If
Return

Int_0:
  Disable Int0
  Enable Interrupts
  Getrc5(address , Command)                                 'odczytywanie danych z pilota
  Command = Command And &B01111111
Return

Mrugnij:
  Set Portb.6
  Gosub Waitms200
  Reset Portb.6
  Gosub Waitms200
Return

Waitms200:
  Waitms 200
Return

Wait_setupbit:
  Gosub Waitms50
  Gosub Setupbit
Return

Wait_setdownbit:
  Gosub Waitms50
  Gosub Setdownbit
Return

Incrktora:
  Pomocbit4 = 255
  Incr Ktora
Return